'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(source, true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(source).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {

  if (!Function.prototype.$asyncbind) {
    Object.defineProperty(Function.prototype, "$asyncbind", {
      value: $asyncbind,
      enumerable: false,
      configurable: true,
      writable: true
    });
  }

  if (!$asyncbind.trampoline) {
    $asyncbind.trampoline = function trampoline(t, x, s, e, u) {
      return function b(q) {
        while (q) {
          if (q.then) {
            q = q.then(b, e);
            return u ? undefined : q;
          }

          try {
            if (q.pop) {
              if (q.length) return q.pop() ? x.call(t) : q;
              q = s;
            } else q = q.call(t);
          } catch (r) {
            return e(r);
          }
        }
      };
    };
  }

  if (!$asyncbind.LazyThenable) {
    $asyncbind.LazyThenable = function () {
      function isThenable(obj) {
        return obj && obj instanceof Object && typeof obj.then === "function";
      }

      function resolution(p, r, how) {
        try {
          var x = how ? how(r) : r;
          if (p === x) return p.reject(new TypeError("Promise resolution loop"));

          if (isThenable(x)) {
            x.then(function (y) {
              resolution(p, y);
            }, function (e) {
              p.reject(e);
            });
          } else {
            p.resolve(x);
          }
        } catch (ex) {
          p.reject(ex);
        }
      }

      function _unchained(v) {}

      function thenChain(res, rej) {
        this.resolve = res;
        this.reject = rej;
      }

      function Chained() {}
      Chained.prototype = {
        resolve: _unchained,
        reject: _unchained,
        then: thenChain
      };

      function then(res, rej) {
        var chain = new Chained();

        try {
          this._resolver(function (value) {
            return isThenable(value) ? value.then(res, rej) : resolution(chain, value, res);
          }, function (ex) {
            resolution(chain, ex, rej);
          });
        } catch (ex) {
          resolution(chain, ex, rej);
        }

        return chain;
      }

      function Thenable(resolver) {
        this._resolver = resolver;
        this.then = then;
      }

      Thenable.resolve = function (v) {
        return Thenable.isThenable(v) ? v : {
          then: function then(resolve) {
            return resolve(v);
          }
        };
      };

      Thenable.isThenable = isThenable;
      return Thenable;
    }();

    $asyncbind.EagerThenable = $asyncbind.Thenable = ($asyncbind.EagerThenableFactory = function (tick) {
      tick = tick || (typeof process === "undefined" ? "undefined" : _typeof(process)) === "object" && process.nextTick || typeof setImmediate === "function" && setImmediate || function (f) {
        setTimeout(f, 0);
      };

      var soon = function () {
        var fq = [],
            fqStart = 0,
            bufferSize = 1024;

        function callQueue() {
          while (fq.length - fqStart) {
            try {
              fq[fqStart]();
            } catch (ex) {}

            fq[fqStart++] = undefined;

            if (fqStart === bufferSize) {
              fq.splice(0, bufferSize);
              fqStart = 0;
            }
          }
        }

        return function (fn) {
          fq.push(fn);
          if (fq.length - fqStart === 1) tick(callQueue);
        };
      }();

      function Zousan(func) {
        if (func) {
          var me = this;
          func(function (arg) {
            me.resolve(arg);
          }, function (arg) {
            me.reject(arg);
          });
        }
      }

      Zousan.prototype = {
        resolve: function resolve(value) {
          if (this.state !== undefined) return;
          if (value === this) return this.reject(new TypeError("Attempt to resolve promise with self"));
          var me = this;

          if (value && (typeof value === "function" || _typeof(value) === "object")) {
            try {
              var first = 0;
              var then = value.then;

              if (typeof then === "function") {
                then.call(value, function (ra) {
                  if (!first++) {
                    me.resolve(ra);
                  }
                }, function (rr) {
                  if (!first++) {
                    me.reject(rr);
                  }
                });
                return;
              }
            } catch (e) {
              if (!first) this.reject(e);
              return;
            }
          }

          this.state = STATE_FULFILLED;
          this.v = value;
          if (me.c) soon(function () {
            for (var n = 0, l = me.c.length; n < l; n++) {
              STATE_FULFILLED(me.c[n], value);
            }
          });
        },
        reject: function reject(reason) {
          if (this.state !== undefined) return;
          this.state = STATE_REJECTED;
          this.v = reason;
          var clients = this.c;
          if (clients) soon(function () {
            for (var n = 0, l = clients.length; n < l; n++) {
              STATE_REJECTED(clients[n], reason);
            }
          });
        },
        then: function then(onF, onR) {
          var p = new Zousan();
          var client = {
            y: onF,
            n: onR,
            p: p
          };

          if (this.state === undefined) {
            if (this.c) this.c.push(client);else this.c = [client];
          } else {
            var s = this.state,
                a = this.v;
            soon(function () {
              s(client, a);
            });
          }

          return p;
        }
      };

      function STATE_FULFILLED(c, arg) {
        if (typeof c.y === "function") {
          try {
            var yret = c.y.call(undefined, arg);
            c.p.resolve(yret);
          } catch (err) {
            c.p.reject(err);
          }
        } else c.p.resolve(arg);
      }

      function STATE_REJECTED(c, reason) {
        if (typeof c.n === "function") {
          try {
            var yret = c.n.call(undefined, reason);
            c.p.resolve(yret);
          } catch (err) {
            c.p.reject(err);
          }
        } else c.p.reject(reason);
      }

      Zousan.resolve = function (val) {
        if (val && val instanceof Zousan) return val;
        var z = new Zousan();
        z.resolve(val);
        return z;
      };

      Zousan.reject = function (err) {
        if (err && err instanceof Zousan) return err;
        var z = new Zousan();
        z.reject(err);
        return z;
      };

      Zousan.version = "2.3.3-nodent";
      return Zousan;
    })();
  }

  function boundThen() {
    return resolver.apply(self, arguments);
  }

  var resolver = this;

  switch (catcher) {
    case true:
      return new $asyncbind.Thenable(boundThen);

    case 0:
      return new $asyncbind.LazyThenable(boundThen);

    case undefined:
      boundThen.then = boundThen;
      return boundThen;

    default:
      return function () {
        try {
          return resolver.apply(self, arguments);
        } catch (ex) {
          return catcher(ex);
        }
      };
  }
};
exports.queries = [];
var cancelledError = {};
exports.globalStateListeners = [];
var uid = 0;
var configContext = React.createContext(); // Focus revalidate

var eventsBinded = false;

if (typeof window !== 'undefined' && !eventsBinded) {
  var revalidate = function revalidate() {
    var _defaultConfig = defaultConfig,
        refetchAllOnWindowFocus = _defaultConfig.refetchAllOnWindowFocus;
    if (refetchAllOnWindowFocus && isDocumentVisible() && isOnline()) refetchAllQueries();
  };

  window.addEventListener('visibilitychange', revalidate, false);
  window.addEventListener('focus', revalidate, false);
  eventsBinded = true;
}

var defaultConfig = {
  retry: 3,
  retryDelay: function retryDelay(attemptIndex) {
    return Math.min(1000 * Math.pow(2, attemptIndex), 30000);
  },
  staleTime: 0,
  cacheTime: 5 * 60 * 1000,
  refetchAllOnWindowFocus: true,
  refetchInterval: false,
  suspense: false,
  queryKeySerializerFn: defaultQueryKeySerializerFn
};
function ReactQueryConfigProvider(_ref) {
  var config = _ref.config,
      children = _ref.children;
  var configContextValue = React.useContext(configContext);
  var newConfig = React.useMemo(function () {
    return _objectSpread2({}, configContextValue || defaultConfig, {}, config);
  }, [config, configContextValue]);

  if (!configContextValue) {
    defaultConfig = newConfig;
  }

  return React.createElement(configContext.Provider, {
    value: newConfig
  }, children);
}

function useConfigContext() {
  return React.useContext(configContext) || defaultConfig;
}

function makeQuery(options) {
  var query = _objectSpread2({}, options, {
    pageVariables: [],
    instances: [],
    state: {
      error: null,
      isFetching: false,
      isFetchingMore: false,
      canFetchMore: false,
      failureCount: 0,
      isCached: false,
      isStale: true,
      data: options.config.paginated ? [] : null
    } // promise: null,
    // staleTimeout: null,
    // cacheTimeout: null,
    // cancelled: null,

  });

  query.setState = function (updater) {
    query.state = functionalUpdate(updater, query.state);
    query.instances.forEach(function (instance) {
      instance.onStateUpdate(query.state);
    });
    exports.globalStateListeners.forEach(function (d) {
      return d();
    });
  };

  query.subscribe = function (instance) {
    var found = query.instances.find(function (d) {
      return d.id === instance.id;
    });

    if (found) {
      Object.assign(found, instance);
    } else {
      found = instance;
      query.instances.push(instance);
    } // Mark as active


    query.setState(function (old) {
      return _objectSpread2({}, old, {
        isInactive: false
      });
    }); // Cancel garbage collection

    clearTimeout(query.cacheTimeout); // Mark the query as not cancelled

    query.cancelled = null; // Return the unsubscribe function

    return function () {
      query.instances = query.instances.filter(function (d) {
        return d.id !== instance.id;
      });

      if (!query.instances.length) {
        // Cancel any side-effects
        query.cancelled = cancelledError; // Mark as inactive

        query.setState(function (old) {
          return _objectSpread2({}, old, {
            isInactive: true
          });
        }); // Schedule garbage collection

        query.cacheTimeout = setTimeout(function () {
          exports.queries.splice(exports.queries.findIndex(function (d) {
            return d === query;
          }), 1);
          exports.globalStateListeners.forEach(function (d) {
            return d();
          });
        }, query.state.isCached ? query.config.cacheTime : 0);
      }
    };
  }; // Set up the fetch function


  var tryFetchQueryPages =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(function* (pageVariables) {
      try {
        // Perform the query
        var data = yield Promise.all(pageVariables.map(function (variables) {
          return query.queryFn(variables);
        }));
        if (query.cancelled) throw query.cancelled;
        return data;
      } catch (error) {
        if (query.cancelled) throw query.cancelled; // If we fail, increase the failureCount

        query.setState(function (old) {
          return _objectSpread2({}, old, {
            failureCount: old.failureCount + 1
          });
        }); // Do we need to retry the request?

        if ( // Only retry if the document is visible
        query.config.retry === true || query.state.failureCount < query.config.retry) {
          if (!isDocumentVisible()) {
            return new Promise(function (r) {});
          } // Determine the retryDelay


          var delay = functionalUpdate(query.config.retryDelay, query.state.failureCount); // Return a new promise with the retry

          return new Promise(function (resolve, reject) {
            // Keep track of the retry timeout
            setTimeout(
            /*#__PURE__*/
            _asyncToGenerator(function* () {
              if (query.cancelled) return reject(query.cancelled);

              try {
                var _data = yield tryFetchQueryPages(pageVariables);

                if (query.cancelled) return reject(query.cancelled);
                resolve(_data);
              } catch (error) {
                if (query.cancelled) return reject(query.cancelled);
                reject(error);
              }
            }), delay);
          });
        }

        throw error;
      }
    });

    return function tryFetchQueryPages(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  query.fetch =
  /*#__PURE__*/
  _asyncToGenerator(function* () {
    var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref5$variables = _ref5.variables,
        variables = _ref5$variables === void 0 ? query.config.paginated && query.state.isCached ? query.pageVariables : query.variables : _ref5$variables,
        force = _ref5.force,
        isFetchMore = _ref5.isFetchMore;

    // Don't refetch fresh queries without force
    if (!query.queryHash || !query.state.isStale && !force) {
      return;
    } // Create a new promise for the query cache if necessary


    if (!query.promise) {
      query.promise = _asyncToGenerator(function* () {
        // If there are any retries pending for this query, kill them
        query.cancelled = null;

        var cleanup = function cleanup() {
          delete query.promise; // Schedule a fresh invalidation, always!

          clearTimeout(query.staleTimeout);
          query.staleTimeout = setTimeout(function () {
            if (query) {
              query.setState(function (old) {
                return _objectSpread2({}, old, {
                  isStale: true
                });
              });
            }
          }, query.config.staleTime);
          query.setState(function (old) {
            return _objectSpread2({}, old, {
              isFetching: false,
              isFetchingMore: false
            });
          });
        };

        try {
          // Set up the query refreshing state
          query.setState(function (old) {
            return _objectSpread2({}, old, {
              error: null,
              isFetching: true,
              isFetchingMore: isFetchMore,
              failureCount: 0
            });
          });
          variables = query.config.paginated && query.state.isCached && !isFetchMore ? variables : [variables]; // Try to fetch

          var data = yield tryFetchQueryPages(variables); // If we are paginating, and this is the first query or a fetch more
          // query, then store the variables in the pageVariables

          if (query.config.paginated && (isFetchMore || !query.state.isCached)) {
            query.pageVariables.push(variables[0]);
          } // Set data and mark it as cached


          query.setState(function (old) {
            data = query.config.paginated ? isFetchMore ? [].concat(_toConsumableArray(old.data), [data[0]]) : data : data[0];
            return _objectSpread2({}, old, {
              data: data,
              isCached: true,
              isStale: false
            }, query.config.paginated && {
              canFetchMore: query.config.getCanFetchMore(data[data.length - 1], data)
            });
          });
          query.instances.forEach(function (instance) {
            return instance.onSuccess && instance.onSuccess(query.state.data);
          });
          cleanup();
          return data;
        } catch (error) {
          // As long as it's not a cancelled retry
          cleanup();

          if (error !== query.cancelled) {
            // Store the error
            query.setState(function (old) {
              return _objectSpread2({}, old, {
                error: error,
                isCached: false,
                isStale: true
              });
            });
            query.instances.forEach(function (instance) {
              return instance.onError && instance.onError(error);
            });
            throw error;
          }
        }
      })();
    }

    return query.promise;
  });

  query.setData = function (updater) {
    return query.setState(function (old) {
      return _objectSpread2({}, old, {
        data: functionalUpdate(updater, old.data)
      });
    });
  };

  return query;
}

function useQuery(queryKey, queryFn) {
  var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var isMountedRef = React.useRef(false);
  var instanceIdRef = React.useRef(uid++);
  var instanceId = instanceIdRef.current;
  config = _objectSpread2({}, useConfigContext(), {}, config);
  var _config = config,
      manual = _config.manual;

  var _config$queryKeySeria = config.queryKeySerializerFn(queryKey),
      _config$queryKeySeria2 = _slicedToArray(_config$queryKeySeria, 4),
      queryHash = _config$queryKeySeria2[0],
      queryGroup = _config$queryKeySeria2[1],
      variablesHash = _config$queryKeySeria2[2],
      variables = _config$queryKeySeria2[3];

  var query = exports.queries.find(function (query) {
    return query.queryHash === queryHash;
  });
  var wasPrefetched;

  if (query) {
    wasPrefetched = query.config.prefetch;
    query.config = config;

    if (!isMountedRef.current) {
      query.config.prefetch = wasPrefetched;
    }

    query.queryFn = queryFn;
  } else {
    query = makeQuery({
      queryHash: queryHash,
      queryGroup: queryGroup,
      variablesHash: variablesHash,
      variables: variables,
      config: config,
      queryFn: queryFn
    });
    exports.queries.push(query);
  }

  React.useEffect(function () {
    if (config.refetchInterval && !query.refetchInterval) {
      query.refetchInterval = setInterval(query.fetch, config.refetchInterval);
      return function () {
        clearInterval(query.refetchInterval);
        query.refetchInterval = null;
      };
    }
  }, [config.refetchInterval, query]);

  var _React$useState = React.useState(query.state),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var onStateUpdate = React.useCallback(function (newState) {
    return setState(newState);
  }, []);
  var getLatestOnError = useGetLatest(config.onError);
  var getLatestOnSuccess = useGetLatest(config.onSuccess);
  React.useEffect(function () {
    var unsubscribeFromQuery = query.subscribe({
      id: instanceId,
      onStateUpdate: onStateUpdate,
      onSuccess: function onSuccess(data) {
        return getLatestOnSuccess() && getLatestOnSuccess()(data);
      },
      onError: function onError(err) {
        return getLatestOnError() && getLatestOnError()(err);
      }
    });
    return unsubscribeFromQuery;
  }, [getLatestOnError, getLatestOnSuccess, instanceId, onStateUpdate, query]);
  var isLoading = !state.isCached && query.state.isFetching;
  var refetch = query.fetch;
  var setData = query.setData;
  var fetchMore = React.useCallback(config.paginated ? function (paginationVariables) {
    return query.fetch({
      variables: paginationVariables,
      force: true,
      isFetchMore: true
    });
  } : undefined, [query]);
  var getLatestManual = useGetLatest(manual);
  React.useEffect(function () {
    if (getLatestManual()) {
      return;
    }

    if (config.suspense) {
      if (isMountedRef.current || wasPrefetched) {
        return;
      }
    }

    var runRefetch =
    /*#__PURE__*/
    function () {
      var _ref7 = _asyncToGenerator(function* () {
        try {
          yield query.fetch();
        } catch (err) {
          console.error(err); // Swallow this error. Don't rethrow it into a render function
        }
      });

      return function runRefetch() {
        return _ref7.apply(this, arguments);
      };
    }();

    runRefetch();
  }, [config.suspense, getLatestManual, query, wasPrefetched]);
  React.useEffect(function () {
    isMountedRef.current = true;
  }, []);

  if (config.suspense) {
    if (state.error) {
      throw state.error;
    }

    if (!state.isCached) {
      throw query.fetch();
    }
  }

  return _objectSpread2({}, state, {
    isLoading: isLoading,
    refetch: refetch,
    fetchMore: fetchMore,
    setData: setData
  });
}
function prefetchQuery(_x2, _x3) {
  return _prefetchQuery.apply(this, arguments);
}

function _prefetchQuery() {
  _prefetchQuery = _asyncToGenerator(function* (queryKey, queryFn) {
    var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    config = _objectSpread2({}, defaultConfig, {}, config, {
      prefetch: true
    });

    var _defaultConfig$queryK3 = defaultConfig.queryKeySerializerFn(queryKey),
        _defaultConfig$queryK4 = _slicedToArray(_defaultConfig$queryK3, 4),
        queryHash = _defaultConfig$queryK4[0],
        queryGroup = _defaultConfig$queryK4[1],
        variablesHash = _defaultConfig$queryK4[2],
        variables = _defaultConfig$queryK4[3]; // If we're prefetching, use the queryFn to make the fetch call


    var query = exports.queries.find(function (query) {
      return query.queryHash === queryHash;
    });

    if (query) {
      if (!config.force) {
        return;
      }

      query.config = config;
      query.queryFn = queryFn;
    } else {
      query = makeQuery({
        queryHash: queryHash,
        queryGroup: queryGroup,
        variablesHash: variablesHash,
        variables: variables,
        config: config,
        queryFn: queryFn
      });
      exports.queries.push(query);
    } // Trigger a query subscription with one-time unique id


    var unsubscribeFromQuery = query.subscribe({
      id: uid++,
      onStateUpdate: function onStateUpdate() {}
    }); // Trigger a fetch and return the promise

    try {
      return yield query.fetch({
        force: config.force
      });
    } finally {
      // Since this is not a hook, upsubscribe after we're done
      unsubscribeFromQuery();
    }
  });
  return _prefetchQuery.apply(this, arguments);
}

function refetchQuery(_x4) {
  return _refetchQuery.apply(this, arguments);
}

function _refetchQuery() {
  _refetchQuery = _asyncToGenerator(function* (queryKey) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _defaultConfig$queryK5 = defaultConfig.queryKeySerializerFn(queryKey),
        _defaultConfig$queryK6 = _slicedToArray(_defaultConfig$queryK5, 4),
        queryGroup = _defaultConfig$queryK6[1],
        variablesHash = _defaultConfig$queryK6[2],
        variables = _defaultConfig$queryK6[3]; // If we're simply refetching an existing query, then go find them
    // and call their fetch functions


    if (!queryGroup) {
      return;
    }

    return Promise.all(exports.queries.map(
    /*#__PURE__*/
    function () {
      var _ref15 = _asyncToGenerator(function* (query) {
        if (query.queryGroup !== queryGroup) {
          return;
        }

        if (variables === false && query.variablesHash) {
          return;
        }

        if (variablesHash && query.variablesHash !== variablesHash) {
          return;
        }

        yield query.fetch({
          force: config.force
        });
      });

      return function (_x6) {
        return _ref15.apply(this, arguments);
      };
    }()));
  });
  return _refetchQuery.apply(this, arguments);
}

function useMutation(mutationFn) {
  var _ref8 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      refetchQueries = _ref8.refetchQueries,
      refetchQueriesOnFailure = _ref8.refetchQueriesOnFailure;

  var _React$useState3 = React.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      data = _React$useState4[0],
      setData = _React$useState4[1];

  var _React$useState5 = React.useState(null),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      error = _React$useState6[0],
      setError = _React$useState6[1];

  var _React$useState7 = React.useState(false),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      isLoading = _React$useState8[0],
      setIsLoading = _React$useState8[1];

  var mutationFnRef = React.useRef();
  mutationFnRef.current = mutationFn;
  var mutate = React.useCallback(
  /*#__PURE__*/
  function () {
    var _ref9 = _asyncToGenerator(function* (variables) {
      var _ref10 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          updateQuery = _ref10.updateQuery,
          _ref10$waitForRefetch = _ref10.waitForRefetchQueries,
          waitForRefetchQueries = _ref10$waitForRefetch === void 0 ? false : _ref10$waitForRefetch;

      setIsLoading(true);
      setError(null);

      var doRefetchQueries =
      /*#__PURE__*/
      function () {
        var _ref11 = _asyncToGenerator(function* () {
          var refetchPromises = refetchQueries.map(function (queryKey) {
            return refetchQuery(queryKey, {
              force: true
            });
          });

          if (waitForRefetchQueries) {
            yield Promise.all(refetchPromises);
          }
        });

        return function doRefetchQueries() {
          return _ref11.apply(this, arguments);
        };
      }();

      try {
        var res = yield mutationFnRef.current(variables);
        setData(res);

        if (updateQuery) {
          setQueryData(updateQuery, res, {
            shouldRefetch: false
          });
        }

        if (refetchQueries) {
          try {
            yield doRefetchQueries();
          } catch (err) {
            console.error(err); // Swallow this error since it is a side-effect
          }
        }

        setIsLoading(false);
        return res;
      } catch (error) {
        setError(error);

        if (refetchQueriesOnFailure) {
          yield doRefetchQueries();
        }

        setIsLoading(false);
        throw error;
      }
    });

    return function (_x5) {
      return _ref9.apply(this, arguments);
    };
  }(), [refetchQueriesOnFailure, refetchQueries]);
  return [mutate, {
    data: data,
    isLoading: isLoading,
    error: error
  }];
}
function useIsFetching() {
  var _React$useState9 = React.useState({
    queries: exports.queries
  }),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      state = _React$useState10[0],
      setState = _React$useState10[1];

  React.useEffect(function () {
    var fn = function fn() {
      setState({
        queries: exports.queries
      });
    };

    exports.globalStateListeners.push(fn);
    return function () {
      exports.globalStateListeners = exports.globalStateListeners.filter(function (d) {
        return d !== fn;
      });
    };
  }, []);
  return React.useMemo(function () {
    return state.queries.some(function (query) {
      return query.isFetching;
    });
  }, [state.queries]);
}
function setQueryData(userQueryKey, updater) {
  var _ref12 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      _ref12$shouldRefetch = _ref12.shouldRefetch,
      shouldRefetch = _ref12$shouldRefetch === void 0 ? true : _ref12$shouldRefetch;

  var _defaultConfig$queryK = defaultConfig.queryKeySerializerFn(userQueryKey),
      _defaultConfig$queryK2 = _slicedToArray(_defaultConfig$queryK, 1),
      queryHash = _defaultConfig$queryK2[0];

  if (!queryHash) {
    return;
  }

  var query = exports.queries.find(function (d) {
    return d.queryHash === queryHash;
  });
  query.setData(updater);

  if (shouldRefetch) {
    return refetchQuery(userQueryKey);
  }
}
function refetchAllQueries() {
  return _refetchAllQueries.apply(this, arguments);
}

function _refetchAllQueries() {
  _refetchAllQueries = _asyncToGenerator(function* () {
    var _ref13 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        includeInactive = _ref13.includeInactive,
        _ref13$force = _ref13.force,
        force = _ref13$force === void 0 ? includeInactive : _ref13$force;

    return Promise.all(exports.queries.map(
    /*#__PURE__*/
    function () {
      var _ref16 = _asyncToGenerator(function* (query) {
        if (query.instances.length || includeInactive) {
          return query.fetch({
            force: force
          });
        }
      });

      return function (_x7) {
        return _ref16.apply(this, arguments);
      };
    }()));
  });
  return _refetchAllQueries.apply(this, arguments);
}

function clearQueryCache() {
  exports.queries = exports.queries.filter(function (query) {
    if (!query.instances.length) {
      query.state.data = null;
      return true;
    }
  });
}

function defaultQueryKeySerializerFn(queryKey) {
  if (!queryKey) {
    return [];
  }

  if (typeof queryKey === 'function') {
    try {
      return defaultQueryKeySerializerFn(queryKey());
    } catch (_unused) {
      return [];
    }
  }

  if (Array.isArray(queryKey)) {
    var _queryKey = _slicedToArray(queryKey, 2),
        id = _queryKey[0],
        variables = _queryKey[1];

    var variablesIsObject = isObject(variables);

    if (typeof id !== 'string' || variables && !variablesIsObject) {
      console.warn('Tuple queryKey:', queryKey);
      throw new Error("Invalid query key tuple type: [".concat(_typeof(id), ", and ").concat(_typeof(variables), "]"));
    }

    var variablesHash = variablesIsObject ? stableStringify(variables) : '';
    return ["".concat(id).concat(variablesHash ? "_".concat(variablesHash, "}") : ''), id, variablesHash, variables];
  }

  return [queryKey, queryKey];
}

function stableStringifyReplacer(_, value) {
  return isObject(value) ? Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.keys(value).sort().map(function (key) {
    return _defineProperty({}, key, value[key]);
  })))) : value;
}

function stableStringify(obj) {
  return JSON.stringify(obj, stableStringifyReplacer);
}

function isObject(a) {
  return a && _typeof(a) === 'object';
}

function isDocumentVisible() {
  return document.visibilityState === undefined || document.visibilityState === 'visible' || document.visibilityState === 'prerender';
}

function isOnline() {
  return navigator.onLine === undefined || navigator.onLine;
}

function useGetLatest(obj) {
  var ref = React.useRef();
  ref.current = obj;
  return React.useCallback(function () {
    return ref.current;
  }, []);
}

function functionalUpdate(updater, old) {
  return typeof updater === 'function' ? updater(old) : updater;
}

exports.ReactQueryConfigProvider = ReactQueryConfigProvider;
exports.clearQueryCache = clearQueryCache;
exports.prefetchQuery = prefetchQuery;
exports.refetchAllQueries = refetchAllQueries;
exports.refetchQuery = refetchQuery;
exports.setQueryData = setQueryData;
exports.stableStringify = stableStringify;
exports.useIsFetching = useIsFetching;
exports.useMutation = useMutation;
exports.useQuery = useQuery;
//# sourceMappingURL=index.js.map
